////////////////////////////////////////////////
// @标题栏控件
////////////////////////////////////////////////

GSApp.UIControls.ArticleToolBar = function () { };

GSApp.UIControls.ArticleToolBar.write = function ()
{
    try
    {
        var html
            = "<div class='GSAppUIControls ArticleToolBar'>"
            + "	<div class='Button Praise' id='gsApp_ContentPraiseButton'>"
            + "		<img src='gsAppHTMLTemplate_image/icon_Praise_20x20@3x.png' />"
            + "		<img class='Selected' src='gsAppHTMLTemplate_image/icon_Praise_20x20_Selected@3x.png' />"
            + "		<span class='Caption'>-</span>"
            + "	</div>"
            + "	<div class='Button Tread' id='gsApp_ContentTreadButton'>"
            + "		<img src='gsAppHTMLTemplate_image/icon_Tread_20x20@3x.png' />"
            + "		<img class='Selected' src='gsAppHTMLTemplate_image/icon_Tread_20x20_Selected@3x.png' />"
            + "		<span class='Caption'>不喜欢</span>"
            + "	</div>"
            + "	<div class='Button Favorite' id='gsApp_ContentFavoriteButton'>"
            + "		<img src='gsAppHTMLTemplate_image/icon_Favorite_20x20@3x.png' />"
            + "		<img class='Selected' src='gsAppHTMLTemplate_image/icon_Favorite_20x20_Selected@3x.png' />"
            + "		<span class='Caption'>收藏</span>"
            + "	</div>"
            + "	<div class='Button Share' id='gsApp_ContentShareButton'>"
            + "		<img src='gsAppHTMLTemplate_image/icon_Share_20x20@3x.png' />"
            + "		<span class='Caption'>分享</span>"
            + "	</div>"
            + "</div>"
        // !!!
        document.write(html);
        // !!!

        // 注册点击事件：
        document.getElementById("gsApp_ContentPraiseButton").onclick
            = function ()
            {
                var gsApp_ContentPraiseButton = document.getElementById("gsApp_ContentPraiseButton");
                var gsApp_ContentTreadButton = document.getElementById("gsApp_ContentTreadButton");
                if (gsApp_ContentPraiseButton.className.indexOf("Selected") < 0
                    && gsApp_ContentTreadButton.className.indexOf("Selected") < 0)
                {
                    GSApp.API.ContentOperate.praiseCurrentContent(
                        function (isPraiseCompleted)
                        {
                            if (isPraiseCompleted)
                            {
                                if (gsApp_ContentPraiseButton.className.indexOf("Selected") != -1) 
                                {
                                    return;    
                                }
                                gsApp_ContentPraiseButton.className
                                    = "Button Praise Selected";

                                var praiseButtonCaption
                                    = gsApp_ContentPraiseButton.getElementsByClassName("Caption")[0];
                                praiseButtonCaption.innerText
                                    = (parseInt(praiseButtonCaption.innerText) + 1).toString();
                            }
                        });
                }
            };
        document.getElementById("gsApp_ContentTreadButton").onclick
            = function ()
            {
                var gsApp_ContentPraiseButton = document.getElementById("gsApp_ContentPraiseButton");
                var gsApp_ContentTreadButton = document.getElementById("gsApp_ContentTreadButton");
                if (gsApp_ContentPraiseButton.className.indexOf("Selected") < 0
                    && gsApp_ContentTreadButton.className.indexOf("Selected") < 0)
                {
                    GSApp.API.ContentOperate.treadCurrentContent(
                        function ()
                        {
                            //if (isPraiseCompleted)
                            {
                                document.getElementById("gsApp_ContentTreadButton").className
                                    = "Button Tread Selected";
                            }
                        });
                }
            };
        document.getElementById("gsApp_ContentFavoriteButton").onclick
            = function ()
            {
                GSApp.API.ContentOperate.collectCurrentContent(
                    function (isFavoriteCompleted)
                    {
                        if (isFavoriteCompleted)
                        {
                            document.getElementById("gsApp_ContentFavoriteButton").className
                                = "Button Favorite Selected";
                        }
                    });
            };
        document.getElementById("gsApp_ContentShareButton").onclick
            = function ()
            {
                GSApp.API.ContentOperate.showShareMenu();
            };

        window.addEventListener(
            "load",
            function ()
            {
                // 更新当前点赞状态：
                GSApp.API.ContentOperate.getPraiseInfoWithContentId(
                    kContentId,
                    function (contentPraiseInfo)
                    {
                        if (contentPraiseInfo)
                        {
                            if (contentPraiseInfo.contentId == kContentId)
                            {
                                var gsApp_ContentPraiseButton
                                    = document.getElementById("gsApp_ContentPraiseButton");
                                if (gsApp_ContentPraiseButton != null)
                                {
                                    if (contentPraiseInfo.praised)
                                    {
                                        gsApp_ContentPraiseButton.className = "Button Praise Selected";
                                    }

                                    gsApp_ContentPraiseButton.getElementsByClassName("Caption")[0].innerText
                                        = contentPraiseInfo.praisesCount;
                                }
                            }
                        }
                    });
            });
    }
    catch (exception)
    {
        console.log(exception);
    }
}
// 兼容旧版本原生点赞回调：
if (typeof (GSApp_OperateBar) == "undefined")
{
    window.GSApp_OperateBar = new Object();
}
GSApp_OperateBar.didPraised = function ()
{

    var gsApp_ContentPraiseButton = document.getElementById("gsApp_ContentPraiseButton");
    var gsApp_ContentTreadButton = document.getElementById("gsApp_ContentTreadButton");
    if (gsApp_ContentPraiseButton.className.indexOf("Selected") < 0
        && gsApp_ContentTreadButton.className.indexOf("Selected") < 0)
    {
        if (gsApp_ContentPraiseButton.className.indexOf("Selected") != -1) 
        {
            return;    
        }
        gsApp_ContentPraiseButton.className
            = "Button Praise Selected";

        var praiseButtonCaption
            = gsApp_ContentPraiseButton.getElementsByClassName("Caption")[0];
        praiseButtonCaption.innerText
            = (parseInt(praiseButtonCaption.innerText) + 1).toString();
    }
};