////////////////////////////////////////////////
// @作者栏
////////////////////////////////////////////////
GSApp.UIControls.AuthorBar = function () { };

GSApp.UIControls.AuthorBar.IsOriginalContent = function () 
{
    if (_kGSAppVersionNumberCode < 5340)
    {
        return false;
    }
    if (kContentSource == "游民星空" ||
        kContentSource == "游民星空[编译]" ||
        kContentSource == "游民星空[原创]" ||
        kContentSource == "动漫星空")
    {
        return true;
    }
    return false;
}

GSApp.UIControls.AuthorBar.write = function ()
{
    try
    {
        // 1/2，初始化作者条UI：
        var authorBarTemplate = "";

        if (typeof (window.kContentAuthorId) == "undefined")
        {
            window.kContentAuthorId = null;
        }
        if (typeof (window.kClubAuthorId) == "undefined")
        {
            window.kClubAuthorId = null;
        }
        if (typeof (kClubAuthorId) == "number")
        {
            kClubAuthorId = kClubAuthorId.toString();
        }

        var authorName = kContentAuthor;
        var contentPublischTime = GSApp.UIControls.captionOfTimeInContent(kContentTime);
        var isGSOriginalArticle = false;
        var isAuthorGSUser = false;
        if (kClubAuthorId != null
            && kClubAuthorId.length > 0)
        {
            isAuthorGSUser = true;
            // !!!
            window.kContentAuthorId = kClubAuthorId;
            // !!!
        }
        else if (GSApp.UIControls.AuthorBar.IsOriginalContent())
        {
            isGSOriginalArticle = true;
            isAuthorGSUser = true;
        }

        if (isAuthorGSUser)
        {
            var authorUserGroup
                = isGSOriginalArticle
                    ? "编辑"
                    : "";

            var userATagHTMLBegin = "";
            var userATagHTMLEnd = "";
            if (kContentAuthorId != null
                && kContentAuthorId != "0"
                && kContentAuthorId.length > 0)
            {
                userATagHTMLBegin = "";
                userATagHTMLEnd = "";
            }
            authorBarTemplate
                =
                "<div id='gsApp_AuthorBar'>" +
                " <div class='Left' onclick='GSApp.openUser(" + kContentAuthorId + ", false);'>" +
                userATagHTMLBegin +
                " <img id='gsApp_AuthorHeadImage'></img>" +
                userATagHTMLEnd +
                " <div class='UserGroupIcon #用户分组类型#' id='gsAuthorGroupIcon'></div>" +
                // " <div class='UserGroupIcon #用户分组类型#' id='gsAuthorGroupIcon'></div>" +
                " </div>" +
                " <div class='Mid' onclick='GSApp.openUser(" + kContentAuthorId + ", false);'>" +
                " <div class='Row'>" +
                userATagHTMLBegin +
                " <span id='gsApp_AuthorName'>" + authorName + "</span>" +
                userATagHTMLEnd +
                /*
                " <span id='gsApp_AuthorThirdPlatformBoundIcon' class='#用户平台绑定名称#'></span>" +
                " <span id='gsApp_AuthorLevel'>Lv#用户等级#</span>" +
                */
                " <span id='gsApp_AuthorGroup'>" + authorUserGroup + "</span>" +
                " </div>" +
                " <div class='Row'>" +
                userATagHTMLBegin +
                " <span id='gsApp_ArticlePublishTime'>" + contentPublischTime + "</span>" +
                userATagHTMLEnd +
                " </div>" +
                " </div>" +
                " <div class='Right'>" +
                " <button id='gsApp_AuthorWatchButton'></button>" +
                " </div>" +
                "</div>"

        }
        else
        {
            var authorUserGroup = kContentSource;
            authorBarTemplate
                =
                "<div id='gsApp_AuthorBar_Unuser'>" +
                authorUserGroup + "&nbsp;&nbsp;" + authorName + "&nbsp;&nbsp;" + contentPublischTime +
                "</div>";
        }
        //
        document.write(authorBarTemplate);
        //

        // 2/2，完善作者信息：
        if (isAuthorGSUser)
        {
            if (window.kContentAuthorId != null &&
                window.kContentAuthorId.length > 0)
            {
                window.addEventListener(
                    "load",
                    function ()
                    {
                        var isAuthorWatched = false;
                        var isGotUserInfo = false;
                        var authorInfo = null;
                        var isGotUserWatchInfo = false;

                        // 关注状态：
                        GSApp.API.UserInfo.isUserIdCurrentUserWatched(
                            window.kContentAuthorId,
                            function (isWatched)
                            {
                                isAuthorWatched = isWatched;
                                isGotUserWatchInfo = true;
                                //
                                if (isGotUserWatchInfo &&
                                    isGotUserInfo)
                                {
                                    GSApp.UIControls.AuthorBar.showAuthorInfo(isAuthorWatched, authorInfo);
                                }
                            });

                        // 用户信息：
                        if (kClubAuthorId != null
                            && kClubAuthorId.length > 0)
                        {
                            if (kClubAuthorHeadImageURL == null
                                || kClubAuthorHeadImageURL.length < 1
                                || kClubAuthorHeadImageURL == "null")
                            {
                                if (typeof (kContentAuthorHeadImageURL) == "string"
                                    && kContentAuthorHeadImageURL != "null")
                                {
                                    kClubAuthorHeadImageURL = kContentAuthorHeadImageURL;
                                }
                            }

                            if (typeof (kClubAuthorHeadImageURL) == "string"
                                && kClubAuthorHeadImageURL.length > 0
                                && kClubAuthorHeadImageURL != "null")
                            {
                                isGotUserInfo = true;
                                authorInfo = new GSApp.Modules.UserInfo(
                                    kClubAuthorId,
                                    kContentAuthor,
                                    kClubAuthorHeadImageURL,
                                    "",
                                    kClubAuthorLevel,
                                    0,
                                    kContentAuthorGroupId,
                                    //
                                    0,
                                    0,
                                    0,
                                    0,
                                    //
                                    "",
                                    "",
                                    "");

                                if (isGotUserWatchInfo
                                    && isGotUserInfo)
                                {
                                    GSApp.UIControls.AuthorBar.showAuthorInfo(isAuthorWatched, authorInfo);
                                }
                            }
                            else 
                            {
                                GSApp.API.UserInfo.getUserInfoWithUserId(
                                    window.kClubAuthorId,
                                    function (userInfo)
                                    {
                                        authorInfo = userInfo;
                                        isGotUserInfo = true;
                                        //
                                        if (isGotUserWatchInfo &&
                                            isGotUserInfo)
                                        {
                                            GSApp.UIControls.AuthorBar.showAuthorInfo(isAuthorWatched, authorInfo);
                                        }
                                    });
                            }
                        }
                        else
                        {
                            isGotUserInfo = true;
                            if (typeof (kContentAuthorHeadImageURL) == "undefined"
                                || kContentAuthorHeadImageURL == null
                                || kContentAuthorHeadImageURL.length < 1)
                            {
                                kContentAuthorHeadImageURL = "gsAppHTMLTemplate_image/image_GamerSkyEditorHeadImage_36x36@3x.png";
                            }
                            authorInfo = new GSApp.Modules.UserInfo(
                                kContentAuthorId,
                                kContentAuthor,
                                kContentAuthorHeadImageURL,
                                "",
                                0,
                                0,
                                0,
                                //
                                0,
                                0,
                                0,
                                0,
                                //
                                "",
                                "",
                                "");
                            if (isGotUserWatchInfo
                                && isGotUserInfo)
                            {
                                GSApp.UIControls.AuthorBar.showAuthorInfo(isAuthorWatched, authorInfo);
                            }
                        }
                    });
            }
            else
            {
                if (typeof (kClubAuthorLevel) == "undefined")
                {
                    window.kClubAuthorLevel = null;
                }
                if (typeof (kContentAuthorGroupId) == "undefined")
                {
                    window.kContentAuthorGroupId = null;
                }

                var authorInfo = new GSApp.Modules.UserInfo(
                    kClubAuthorId,
                    kContentAuthor,
                    "gsAppHTMLTemplate_image/image_GamerSkyEditorHeadImage_36x36@3x.png",
                    "",
                    kClubAuthorLevel,
                    0,
                    kContentAuthorGroupId,
                    //
                    0,
                    0,
                    0,
                    0,
                    //
                    "",
                    "",
                    "");
                { }
                GSApp.UIControls.AuthorBar.showAuthorInfo(false, authorInfo);
            }
        }
    }
    catch (exception)
    {
        console.log(exception);
    }
}

GSApp.UIControls.AuthorBar.showAuthorInfo = function (isAuthorWatched, authorInfo)
{
    if (authorInfo != null)
    {
        var authorName = document.getElementById("gsApp_AuthorName");
        if (authorName != null)
        {
            authorName.innerText = authorInfo.userName;
        }

        var authorHeadImage = document.getElementById("gsApp_AuthorHeadImage");
        if (authorHeadImage != null)
        {
            authorHeadImage.src = authorInfo.userHeadImageURL;
        }
        authorHeadImage.style.opacity = 1.0;
    }

    if ((typeof (kUserId) == "undefined"
        || kUserId != window.kContentAuthorId)
        && window.kContentAuthorId != null
        && window.kContentAuthorId != ""
        && window.kContentAuthorId != "0")
    {
        var gsApp_AuthorWatchButton = document.getElementById("gsApp_AuthorWatchButton");
        if (isAuthorWatched == true
            || isAuthorWatched == 1)
        {
            gsApp_AuthorWatchButton.className = "Watched";
        } else
        {
            gsApp_AuthorWatchButton.className = "Unwatched";
        }

        gsApp_AuthorWatchButton.onclick = function ()
        {
            if (gsApp_AuthorWatchButton.className == "Watched")
            {
                GSApp.API.UserInfo.currentUser_CancelWatchUser(
                    authorInfo.userId,
                    function (isOperateCompleted)
                    {
                        // if (isOperateCompleted)
                        // {

                        gsApp_AuthorWatchButton.className = "Unwatched";
                        // !!!
                        GSApp.showTips("已取消关注");
                        // !!!

                        // }
                        // else
                        // {
                        //     gsApp_AuthorWatchButton.className = "Watched";
                        // }
                    });

            }
            else
            {
                GSApp.API.UserInfo.currentUser_WatchUser(
                    authorInfo.userId,
                    function (isOperateCompleted)
                    {
                        // if (isOperateCompleted)
                        // {

                        gsApp_AuthorWatchButton.className = "Watched";
                        // !!!
                        GSApp.showTips("关注成功");
                        // !!!

                        // }
                        // else
                        // {
                        //     gsApp_AuthorWatchButton.className = "Unwatched";
                        // }
                    });
            }
        }
    }
}

GSApp.UIControls.AuthorBar.createEditorHtml = function ()
{
    if (GSApp.UIControls.AuthorBar.IsOriginalContent())
    {
        return "";
    }
    if (typeof (kContentEditor) == "undefined"
        || kContentEditor == null
        || kContentEditor.length < 1)
    {
        return "";
    }

    var editorHTML
        = "<p class=\"ContentEditor\">"
        + "责任编辑：" + kContentEditor
        + "</p>"
    { }
    return editorHTML;
}

GSApp.UIControls.AuthorBar.writeEditor = function ()
{
    if (GSApp.UIControls.AuthorBar.IsOriginalContent())
    {
        return;
    }
    if (typeof (kContentEditor) == "undefined"
        || kContentEditor == null
        || kContentEditor.length < 1)
    {
        return;
    }

    var editorHTML = GSApp.UIControls.AuthorBar.createEditorHtml();
    { }
    document.write(editorHTML);
}